<?php
//echo 'hola';
//ini_set('display_errors', '1');
use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

require '../../vendor/autoload.php';
require 'config/db.php';
$app = new \Slim\App(['settings' => [
										'displayErrorDetails' => true
										, 'addContentLengthHeader' => false
   ]]);


function processMethod($pSql) {
	try {
		$db = new db();
		$db = $db->connect();
		$stmt = $db->prepare($pSql);
		$success = $stmt->execute();
		if ($success) {
			$rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
			echo json_encode($rows, JSON_NUMERIC_CHECK);
		}
		$db = null;
	} catch(PDOException $e) {
		echo '[{"Error_Text": "'.$e->getMessage().'"}]';
	}
}

/* Method 1: List */
$app->get('/Despachos', function (Request $request, Response $response) {
	$sql = "CALL entregal_shawarma.ListaDespachos();";
	processMethod($sql);
});

/* Method 1: List */
$app->get('/FormasPago', function (Request $request, Response $response) {
	$sql = "CALL entregal_shawarma.ListaFormasPago();";
	processMethod($sql);
});

/* Method 1: List */
$app->get('/Pedidos', function (Request $request, Response $response) {
	$sql = "CALL entregal_shawarma.ListaPedidos();";
	processMethod($sql);
});

/* Method 2: Show */
$app->get('/Pedidos/{pPedido_Id}', function (Request $request, Response $response) {
	$pPedido_Id = $request->getAttribute('pPedido_Id');
	$sql = "CALL entregal_shawarma.MuestraPedido($pPedido_Id);";
	processMethod($sql);
});

/* Method 3: Save */
$app->post('/Pedidos/{pPedido_Id}&{pPedido_ClienteNombre}&{pPedido_ClienteTelefono}&{pPedido_ClienteDireccion}&{pPedido_SubTotal}&{pPedido_Descuento}&{pPedido_Total}&{pPedido_Estado}&{pFormaPago_Id}&{pDespacho_Id}&{pPedido_Comentarios}&{pPedido_Pagado}', function (Request $request, Response $response) {
	$pPedido_Id = $request->getAttribute('pPedido_Id');
	$pPedido_ClienteNombre = ($request->getAttribute('pPedido_ClienteNombre')=='null' ? $request->getAttribute('pPedido_ClienteNombre') : "'" . $request->getAttribute('pPedido_ClienteNombre') . "'");
	$pPedido_ClienteTelefono = ($request->getAttribute('pPedido_ClienteTelefono')=='null' ? $request->getAttribute('pPedido_ClienteTelefono') : "'" . $request->getAttribute('pPedido_ClienteTelefono') . "'");
	$pPedido_ClienteDireccion = ($request->getAttribute('pPedido_ClienteDireccion')=='null' ? $request->getAttribute('pPedido_ClienteDireccion') : "'" . $request->getAttribute('pPedido_ClienteDireccion') . "'");
	$pPedido_SubTotal = $request->getAttribute('pPedido_SubTotal');
	$pPedido_Descuento = $request->getAttribute('pPedido_Descuento');
	$pPedido_Total = $request->getAttribute('pPedido_Total');
	$pPedido_Estado = "'" . $request->getAttribute('pPedido_Estado') . "'";
	$pFormaPago_Id = $request->getAttribute('pFormaPago_Id');
	$pDespacho_Id = $request->getAttribute('pDespacho_Id');
	$pPedido_Comentarios = ($request->getAttribute('pPedido_Comentarios')=='null' ? $request->getAttribute('pPedido_Comentarios') : "'" . $request->getAttribute('pPedido_Comentarios') . "'");
	$pPedido_Pagado = $request->getAttribute('pPedido_Pagado');
	$sql = "CALL entregal_shawarma.GuardaPedido($pPedido_Id, $pPedido_ClienteNombre, $pPedido_ClienteTelefono, $pPedido_ClienteDireccion, $pPedido_SubTotal, $pPedido_Descuento, $pPedido_Total , $pPedido_Estado, $pFormaPago_Id, $pDespacho_Id, $pPedido_Comentarios, $pPedido_Pagado);";
	processMethod($sql);
});

/* Method 4: Delete */
$app->post('/Pedidos/Eliminar/{pPedido_Id}', function (Request $request, Response $response) {
	$pPedido_Id = $request->getAttribute('pPedido_Id');
	$sql = "CALL entregal_shawarma.EliminaPedido($pPedido_Id)";
	processMethod($sql);
});

/* Method 1: List */
$app->get('/PedidoProductos/{pPedido_Id}', function (Request $request, Response $response) {
	$pPedido_Id = $request->getAttribute('pPedido_Id');
	$sql = "CALL entregal_shawarma.ListaPedidoProducto($pPedido_Id);";
	processMethod($sql);
});

/* Method 3: Save */
$app->post('/PedidoProductos/{pPedido_Id}&{pProducto_Id}&{pPedido_Producto_PrecioUnitario}&{pPedido_Producto_Cantidad}&{pPedido_Producto_SubTotal}', function (Request $request, Response $response) {
	$pPedido_Id = $request->getAttribute('pPedido_Id');
	$pProducto_Id = $request->getAttribute('pProducto_Id');
	$pPedido_Producto_PrecioUnitario = $request->getAttribute('pPedido_Producto_PrecioUnitario');
	$pPedido_Producto_Cantidad = $request->getAttribute('pPedido_Producto_Cantidad');
	$pPedido_Producto_SubTotal = $request->getAttribute('pPedido_Producto_SubTotal');
	$sql = "CALL entregal_shawarma.GuardaPedidoProducto($pPedido_Id, $pProducto_Id, $pPedido_Producto_PrecioUnitario, $pPedido_Producto_Cantidad, $pPedido_Producto_SubTotal);";
	processMethod($sql);
});

/* Method 1: List */
$app->get('/Productos/Todos/{pProducto_FlagMuestraInactivos}', function (Request $request, Response $response) {
	$pProducto_FlagMuestraInactivos = $request->getAttribute('pProducto_FlagMuestraInactivos');
	$sql = "CALL entregal_shawarma.ListaProductos($pProducto_FlagMuestraInactivos);";
	processMethod($sql);
});

/* Method 2: Show */
$app->get('/Productos/{pProducto_Id}', function (Request $request, Response $response) {
	$pProducto_Id = $request->getAttribute('pProducto_Id');
	$sql = "CALL entregal_shawarma.MuestraProducto($pProducto_Id);";
	processMethod($sql);
});

/* Method 3: Save */
$app->post('/Productos/{pProducto_Id}&{pProducto_Nombre}&{pProducto_PrecioUnitario}&{pProducto_Activo}&{pProducto_Stock}&{pProducto_StockMinimoAlerta}&{pProducto_UnidadStock}&{pProducto_FlagDescuentaPropioStock}&{pProducto_IdDescuentoStock1}&{pProducto_DescuentoStockPorUnidad1}&{pProducto_IdDescuentoStock2}&{pProducto_DescuentoStockPorUnidad2}&{pProducto_IdDescuentoStock3}&{pProducto_DescuentoStockPorUnidad3}&{pProducto_IdDescuentoStock4}&{pProducto_DescuentoStockPorUnidad4}', function (Request $request, Response $response) {
	$pProducto_Id = $request->getAttribute('pProducto_Id');
	$pProducto_Nombre = ($request->getAttribute('pProducto_Nombre')=='null' ? $request->getAttribute('pProducto_Nombre') : "'" . $request->getAttribute('pProducto_Nombre') . "'");
	$pProducto_PrecioUnitario = $request->getAttribute('pProducto_PrecioUnitario');
	//$pProducto_Imagen = ($request->getAttribute('pProducto_Imagen')=='null' ? $request->getAttribute('pProducto_Imagen') : "'" + $request->getAttribute('pProducto_Imagen') + "'");
	$pProducto_Activo = $request->getAttribute('pProducto_Activo');
	$pProducto_Stock = $request->getAttribute('pProducto_Stock');
	$pProducto_StockMinimoAlerta = $request->getAttribute('pProducto_StockMinimoAlerta');
	$pProducto_UnidadStock = ($request->getAttribute('pProducto_UnidadStock')=='null' ? $request->getAttribute('pProducto_UnidadStock') : "'" . $request->getAttribute('pProducto_UnidadStock') . "'");
	$pProducto_FlagDescuentaPropioStock = $request->getAttribute('pProducto_FlagDescuentaPropioStock');
	$pProducto_IdDescuentoStock1 = $request->getAttribute('pProducto_IdDescuentoStock1');
	$pProducto_DescuentoStockPorUnidad1 = $request->getAttribute('pProducto_DescuentoStockPorUnidad1');
	$pProducto_IdDescuentoStock2 = $request->getAttribute('pProducto_IdDescuentoStock2');
	$pProducto_DescuentoStockPorUnidad2 = $request->getAttribute('pProducto_DescuentoStockPorUnidad2');
	$pProducto_IdDescuentoStock3 = $request->getAttribute('pProducto_IdDescuentoStock3');
	$pProducto_DescuentoStockPorUnidad3 = $request->getAttribute('pProducto_DescuentoStockPorUnidad3');
	$pProducto_IdDescuentoStock4 = $request->getAttribute('pProducto_IdDescuentoStock4');
	$pProducto_DescuentoStockPorUnidad4 = $request->getAttribute('pProducto_DescuentoStockPorUnidad4');
	$sql = "CALL entregal_shawarma.GuardaProducto($pProducto_Id, $pProducto_Nombre, $pProducto_PrecioUnitario, '', $pProducto_Activo, $pProducto_Stock, $pProducto_StockMinimoAlerta, $pProducto_UnidadStock, $pProducto_FlagDescuentaPropioStock, $pProducto_IdDescuentoStock1, $pProducto_DescuentoStockPorUnidad1, $pProducto_IdDescuentoStock2, $pProducto_DescuentoStockPorUnidad2, $pProducto_IdDescuentoStock3, $pProducto_DescuentoStockPorUnidad3, $pProducto_IdDescuentoStock4, $pProducto_DescuentoStockPorUnidad4);";
	processMethod($sql);
});

/* Method 1: List */
$app->get('/ResumenVentas', function (Request $request, Response $response) {
	$sql = "CALL entregal_shawarma.MuestraResumenVentas();";
	processMethod($sql);
});

/* Method 2: Show */
$app->get('/Pedidos/Entregar/{pPedido_Id}', function (Request $request, Response $response) {
	$pPedido_Id = $request->getAttribute('pPedido_Id');
	$sql = "CALL entregal_shawarma.EntregaPedido($pPedido_Id);";
	processMethod($sql);
});

/* Method 1: List */
$app->get('/ProductosStockBajo', function (Request $request, Response $response) {
	$sql = "CALL entregal_shawarma.ListaProductosStockBajo();";
	processMethod($sql);
});

$app->run();
